/*
 *	app.h
 *
 *	AvP[ṼCwb_t@CłB
 *
 *	* Mon Feb 12 04:37:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include "clip.h"

/****************************************************************************
 *	`
 ****************************************************************************/

extern unsigned char _def_vbuff[DISP_X * DISP_Y]; /* zVRAM */
#define vbuff _def_vbuff

#define FPS	/*TODO:*/20		/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

/* Xe[g` */
enum {
	STATE_DEMO,		/* f */
	STATE_GAME,		/* Q[ */
	/*TODO:STATE_name,*/
	N_STATES,		/* Xe[g̐ */
};

/* LN^` */
typedef struct _CHR {
	PIECE_BMP* bmp;		/* ]rbg}bv */
	unsigned char x, y;	/* ]̍W */
	unsigned char w, h;	/* ]TCY */
} CHR;
#define DEFCHR(n, b, x, y, w, h) CHR_##n,
enum {				/* LN^ԍ */
#include "chr.h"
	N_CHRS,			/* LN^ */
};
#undef DEFCHR

/****************************************************************************
 *	ϐ
 ****************************************************************************/

extern char state[(N_STATES + 7) / 8];	/* Xe[g */
extern TASK* root_task;			/* [g^XN */
extern TASK* game_task;			/* Q[^XN */
extern int timer;			/* ^C} */
extern int pad;				/* pbh */
//extern PIECE_BMP bmp1;			/* 1bitf[^ */
extern PIECE_BMP bmp2;			/* 2bitf[^ */
extern PIECE_BMP bmp2m;			/* 2bitf[^maskt */

/****************************************************************************
 *	֐
 ****************************************************************************/

/* data.c */
//extern const unsigned char BMP1[];	/* 1bitf[^ */
extern const unsigned char BMP2[];	/* 2bitf[^ */
extern const unsigned char BMP2M[];	/* 2bitf[^maskt */
extern CHR chrs[N_CHRS];		/* LN^e[u */

/* main.c */
void schedule();
void delay(int n);
int main();

/* misc.c */
void putchr(int x, int y, CHR* chr, int param);
void putchrno(int x, int y, int chrno, int param);
void setfont(int type, int txcolor, int bkcolor);
void putstr(int x, int y, const char* str);
void putstrf(int x, int y, const char* fmt, ...);

/* demo.c */
void demo();

/* game.c */
void game();

#endif /*__APP_H__*/
