/*
 *	misc.c
 *
 *	* Mon Feb 12 22:15:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	putchr
 ****************************************************************************/

void
putchr(int x, int y, CHR* chr, int param)
{
	DRAW_OBJECT obj;
	pceLCDSetObject(&obj, chr->bmp, x, y, chr->x, chr->y, chr->w, chr->h, param);
	pceLCDDrawObject(obj);
}

/****************************************************************************
 *	putchrno
 ****************************************************************************/

void
putchrno(int x, int y, int chrno, int param)
{
#ifdef DEBUG
	if(chrno < 0 || N_CHRS <= chrno) DIE();
#endif /*DEBUG*/
	putchr(x, y, &chrs[chrno], param);
}

/****************************************************************************
 *	setfont
 ****************************************************************************/

void
setfont(int type, int txcolor, int bkcolor)
{
	pceFontSetType(type);
	pceFontSetTxColor(txcolor);
	pceFontSetBkColor(bkcolor);
}

/****************************************************************************
 *	putstr
 ****************************************************************************/

void
putstr(int x, int y, const char* str)
{
	pceFontSetPos(x, y);
	pceFontPutStr(str);
}

/****************************************************************************
 *	putstr
 ****************************************************************************/

void
putstrf(int x, int y, const char* fmt, ...)
{
	char* str = (char*)0x1000; /* [U[X^bŇEʒu */
	va_list ap;
	va_start(ap, fmt);
	vsprintf(str, fmt, ap);
	va_end(ap);
	putstr(x, y, str);
}
